--[[
TODO:

]]

-- Global variables
PistonTickDelay = 1
Plugin = {}
PluginString = ""

function Initialize( inPlugin )
	Plugin = inPlugin
	Plugin:SetName( "PistonRock" )
	Plugin:SetVersion( 1 )
	cPluginManager.AddHook( cPluginManager.HOOK_PLAYER_USING_ITEM, OnPlayerUsingItem )
	
	PluginSting = Plugin:GetName().." v"..Plugin:GetVersion()
	LOG( "Initialized "..PluginSting )
	return true
end

function OnDisable()
	LOG( PluginSting.." is shutting down..." )
end

function OnPlayerUsingItem( inPlayer, inX, inY, inZ, inFace, inCursorX, inCursorY, inCursorZ, inBlockType, inBlockMeta )
	if( inFace == BLOCK_FACE_NONE ) then
		return false
	end

	local heldItem = inPlayer:GetEquippedItem()
	local heldItemType = heldItem.m_ItemType
	local blockValid, blockType, blockMeta, blockSkyLight, blockBlockLight = inPlayer:GetWorld():GetBlockInfo( inX, inY, inZ )
	
	if( blockValid ) then
		if( heldItemType == E_ITEM_BLAZE_ROD ) then
			inPlayer:SendMessage( "Block info (type, meta, SL, BL) : "..blockType..", "..blockMeta..", "..blockSkyLight..", "..blockBlockLight )
		elseif( heldItemType == E_ITEM_DIAMOND ) then
			local world = inPlayer:GetWorld()
			local noErrors, newX, newY, newZ = ShiftCoordinates( inX, inY, inZ, inFace )
			if( noErrors ) then
				world:BroadcastBlockAction( newX, newY, newZ, 0, inFace, E_BLOCK_PISTON )
				world:QueueSetBlock( inX, inY, inZ, E_BLOCK_AIR, 0, PistonTickDelay )
			end
		end
	else
		inPlayer:SendMessage( "Invalid block clicked, sorry, man :(" )
	end
end

function ShiftCoordinates( inX, inY, inZ, inFace )
	local noErrors, shiftX, shiftY, shiftZ = GetShifts( inX, inY, inZ, inFace )
	if( noErrors ) then
		return true, inX - shiftX, inY - shiftY, inZ - shiftZ
	else
		return false, inX, inY, inZ
	end
end

function GetShifts( inX, inY, inZ, inFace )
	if( inFace == BLOCK_FACE_BOTTOM ) then
		return true, 0, -1, 0
	elseif( inFace == BLOCK_FACE_TOP ) then
		return true, 0, 1, 0
	elseif( inFace == BLOCK_FACE_ZM ) then
		return true, 0, 0, -1
	elseif( inFace == BLOCK_FACE_ZP ) then
		return true, 0, 0, 1
	elseif( inFace == BLOCK_FACE_XM ) then
		return true, -1, 0, 0
	elseif( inFace == BLOCK_FACE_XP ) then
		return true, 1, 0, 0
	else
		LOGWARNING( PluginSting.." detected invalid block face @ x:"..inX..", y:"..inY..", z:"..inZ )
		return false, 0, 0, 0
	end
end